Kattis-Low Power【二分】

来源:互联网 发布:smb端口号 xp 编辑:程序博客网 时间:2024/05/17 08:36

Kattis-Low Power


You are building advanced chips for machines. Making the chips is easy, but the power supply turns out to be an issue since the available batteries have varied power outputs.

Consider the problem of n machines, each with two chips, where each chip is powered by k
batteries. Surprisingly, it does not matter how much power each chip gets, but a machine works best when its two chips have power outputs as close as possible. The power output of a chip is simply the smallest power output of its k
batteries.

You have a stockpile of 2nk
batteries that you want to assign to the chips. It might not be possible to allocate the batteries so that in every machine both chips have equal power outputs, but you want to allocate them so that the differences are as small as possible. To be precise, you want to tell your customers that in all machines the difference of power outputs of the two chips is at most d, and you want to make d as small as possible. To do this you must determine an optimal allocation of the batteries to the machines.

Consider Sample Input 1. There are 2
machines, each requiring 3
batteries per chip, and a supply of batteries with power outputs 1,2,3,4,5,6,7,8,9,10,11,12. You can, for instance, assign the batteries with power outputs 1,3,5 to one chip, those with power 2,4,12 to the other chip of the same machine, those with power 6,8,9 to the third chip, and those with power 7,10,11 to the fourth. The power outputs of the chips are 1,2,6, and 7, respectively, and the difference between power outputs is 1 in both machines. Note that there are many other ways to achieve this result.

Input
The input consists of a single test case. A test case consists of two lines. The first line contains two positive integers: the number of machines n and the number of batteries per chip k (2nk≤106). The second line contains 2nk integers pi specifying the power outputs of the batteries (1≤pi≤109).

Output
Display the smallest number d
such that you can allocate the batteries so that the difference of power outputs of the two chips in each machine is at most d

题目链接:Kattis-Low Power

题目大意:一台机器有两个芯片(A/B),每个芯片有k个电池。

设A芯片中电池功率最小的那一个与B芯片中功率最小的那个差值为d

现在有n台机器,有2 * n * k 个电池。

问:如何分配电池,使得n台机器的最大的d最小

题目思路:二分d。然后判断当前d是否能满足条件:

先将电池按照功率从小到大排序:遍历电池,找出两个电池间差值小于当前d的对数.(用作一台机器的两个最小功率电池)不满足的条件是:    i : 假设已经遍历到第20个电池    k: 每个芯片需要3个电池,    p: 已经找到2对满足条件的电池    ⇒ i > 2 * p * k,也就是说只有两台机器满足条件,填充完只能用掉12个电池。    多余了8个电池,后面的机器如果找到一对满足条件的电池也是不行的。    因为后面的电池无法作为最小的。可得到:for (int i = 0, p = 0; p < n; i++){    if (i > p * 2 * k) return false;    if (num[i + 1] - num[i] <= w) p++,i++;  //说明这一对可以作为差值}

以下是代码:

#include <iostream>#include <iomanip>#include <fstream>#include <sstream>#include <cmath>#include <cstdio>#include <cstring>#include <cctype>#include <algorithm>#include <functional>#include <numeric>#include <string>#include <set>#include <map>#include <stack>#include <vector>#include <queue>#include <deque>#include <list>using namespace std;int num[1000005];int n,k;bool isOk(int w){    for (int i = 0, p = 0; p < n; i++)    {        if (i > p * 2 * k) return false;        if (num[i + 1] - num[i] <= w) p++,i++;  //说明这一对可以作为差值    }    return true;}int main(){    cin >> n >> k;    int maxnum = 0;    for (int i = 0; i < 2 * n * k; i++)    {        cin >> num[i];        maxnum = max(maxnum, num[i]);    }    sort(num, num + 2 * n * k);    int l = 0, r = maxnum;    int mid;    while(l < r)    {        mid = (l + r) / 2;        if (isOk(mid)) r = mid;        else l = mid + 1;    }    cout << l << endl;    return 0;}

.

0 0